import random2000.De;

public class Joueur {
  private String nom;
  private Pion pion;
  private random2000.De de;
  public Joueur(String n,Pion p,De d) {
    nom = n;
    pion = p;
    de = d;
  }
  public void joue() {
    int tirage = de.jet();
    System.out.println(this+ " tire "+tirage);
    Mouvement m = new Mouvement();
    for (int i=0; i<tirage; i++) {
      Plateau.Case laCase = pion.enleveDeLaCase();
      pion.deposeSurLaCase(laCase.suivante(m));
    }
  }
  public boolean aGagne() {
    return pion.surDerniereCase();
  }
  public void poseSonPion(Plateau p) {
    p.add(pion);
  }
  public String toString() {
    return nom;
  }
}
